Debian Bug report logs - #522141
xterm 242 sometimes draws spaces without background color

version graph

Package: xterm; Maintainer for xterm is Debian X Strike Force <debian-x@lists.debian.org>; Source for xterm is src:xterm.

Reported by: Matt Wozniski <mjw@drexel.edu>

Date: Wed, 1 Apr 2009 05:54:02 UTC

Severity: normal

Tags: confirmed, fixed-upstream, upstream

Found in version xterm/242-1

Fixed in version xterm/244-1

Done: Julien Cristau <jcristau@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#522141; Package xterm. (Wed, 01 Apr 2009 05:54:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Matt Wozniski <mjw@drexel.edu>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 01 Apr 2009 05:54:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Matt Wozniski <mjw@drexel.edu>
To: submit@bugs.debian.org
Subject: xterm 242 sometimes draws spaces without background color
Date: Wed, 1 Apr 2009 01:52:08 -0400
Package: xterm
Version: 242-1
Severity: normal

A regression seems to have been introduced in xterm 242 in handling
spaces with a background color set: sometimes they will be drawn as
though no background color was specified.  A simple test case:

# Open a vim process with a red background in xterm
xterm -e 'vim -u NONE -N +"hi Normal ctermbg=red"'

# Insert a line of 50 spaces
50i<space><esc>

# Start moving the cursor left
hhhhhhhhhh

# Notice that most of the screen is red, but the spaces that you've
# moved over aren't colored and appear black.

Removing some lines from charproc.c, as shown below, stops this regression, but
I'm sure it breaks other things - I couldn't quite figure out what, though...
In any event, I don't think these two blocks are behaving as they ought to.

~Matt

diff --git a/charproc.c b/charproc.c
index 97e1c9d..22148c4 100644
--- a/charproc.c
+++ b/charproc.c
@@ -6904,8 +6904,6 @@ ShowCursor(void)
 #if OPT_ISO_COLORS
     if (base == ' ') {
 	if ((flags & (FG_COLOR | BG_COLOR)) == BG_COLOR) {
-	    TRACE(("ShowCursor - do not treat as a colored cell\n"));
-	    flags &= ~(FG_COLOR | BG_COLOR);
 	} else if ((flags & (FG_COLOR | BG_COLOR)) == FG_COLOR) {
 	    TRACE(("ShowCursor - should we treat as a colored cell?\n"));
 	    if (!(xw->flags & FG_COLOR))
@@ -7141,8 +7139,6 @@ HideCursor(void)
 #if OPT_ISO_COLORS
     if (base == ' ') {
 	if ((flags & (FG_COLOR | BG_COLOR)) == BG_COLOR) {
-	    TRACE(("HideCursor - do not treat as a colored cell\n"));
-	    flags &= ~(FG_COLOR | BG_COLOR);
 	} else if ((flags & (FG_COLOR | BG_COLOR)) == FG_COLOR) {
 	    TRACE(("HideCursor - should we treat as a colored cell?\n"));
 	    if (!(xw->flags & FG_COLOR))

-- System Information:
Debian Release: squeeze/sid
 APT prefers unstable
 APT policy: (500, 'unstable')
Architecture: i386 (i686)

Kernel: Linux 2.6.29-rc7-2009-03-11+1236796607+bisect (SMP w/2 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages xterm depends on:
ii  libc6                     2.9-6          GNU C Library: Shared libraries
ii  libfontconfig1            2.6.0-3        generic font configuration library
ii  libice6                   2:1.0.5-1      X11 Inter-Client Exchange library
ii  libncurses5               5.7+20090321-1 shared libraries for terminal hand
ii  libx11-6                  2:1.2-1        X11 client-side library
ii  libxaw7                   2:1.0.5-2      X11 Athena Widget library
ii  libxft2                   2.1.13-3       FreeType-based font drawing librar
ii  libxmu6                   2:1.0.4-1      X11 miscellaneous utility library
ii  libxt6                    1:1.0.5-3      X11 toolkit intrinsics library
ii  xbitmaps                  1.0.1-2        Base X bitmaps

Versions of packages xterm recommends:
ii  x11-utils                     7.4+1      X11 utilities
ii  xutils                        1:7.3+18   X Window System utility programs m

Versions of packages xterm suggests:
pn  xfonts-cyrillic               <none>     (no description available)

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#522141; Package xterm. (Sun, 05 Apr 2009 23:48:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 05 Apr 2009 23:48:02 GMT) Full text and rfc822 format available.

Message #10 received at 522141@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Matt Wozniski <mjw@drexel.edu>
Subject: Re: xterm 242 sometimes draws spaces without background color
Date: Mon, 06 Apr 2009 01:45:22 +0200
On Wed, Apr 01, 2009 at 01:52:08AM -0400, Matt Wozniski wrote:
> # Open a vim process with a red background in xterm
> xterm -e 'vim -u NONE -N +"hi Normal ctermbg=red"'
> 
> # Insert a line of 50 spaces
> 50i<space><esc>
> 
> # Start moving the cursor left
> hhhhhhhhhh
> 
> # Notice that most of the screen is red, but the spaces that you've
> # moved over aren't colored and appear black.
> 
I can reproduce this.  If you hide and show the xterm window, they get
colored red again.

Cheers,
Julien





Message sent on to Matt Wozniski <mjw@drexel.edu>:
Bug#522141. (Mon, 06 Apr 2009 23:18:02 GMT) Full text and rfc822 format available.

Message #13 received at 522141-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 522141-submitter@bugs.debian.org
Subject: Re: Bug#522141: xterm 242 sometimes draws spaces without background color
Date: Mon, 6 Apr 2009 19:17:19 -0400
[Message part 1 (text/plain, inline)]
On Mon, Apr 06, 2009 at 02:00:13AM +0200, Julien Cristau wrote:
> On Wed, Apr 01, 2009 at 01:52:08AM -0400, Matt Wozniski wrote:
> > # Open a vim process with a red background in xterm
> > xterm -e 'vim -u NONE -N +"hi Normal ctermbg=red"'
> > 
> > # Insert a line of 50 spaces
> > 50i<space><esc>
> > 
> > # Start moving the cursor left
> > hhhhhhhhhh
> > 
> > # Notice that most of the screen is red, but the spaces that you've
> > # moved over aren't colored and appear black.
> > 
> I can reproduce this.  If you hide and show the xterm window, they get
> colored red again.

same here (looks like it got broken in one of my cleanup changes,
since it's working in the binary I made on the 25th, but broken
on the 28th).

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Message sent on to Matt Wozniski <mjw@drexel.edu>:
Bug#522141. (Mon, 06 Apr 2009 23:42:03 GMT) Full text and rfc822 format available.

Message #16 received at 522141-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 522141-submitter@bugs.debian.org
Cc: Thomas Dickey <dickey@radix.net>
Subject: Re: Bug#522141: xterm 242 sometimes draws spaces without background color
Date: Mon, 6 Apr 2009 19:39:07 -0400
[Message part 1 (text/plain, inline)]
On Mon, Apr 06, 2009 at 07:17:19PM -0400, Thomas Dickey wrote:
> On Mon, Apr 06, 2009 at 02:00:13AM +0200, Julien Cristau wrote:
> > On Wed, Apr 01, 2009 at 01:52:08AM -0400, Matt Wozniski wrote:
> > > # Open a vim process with a red background in xterm
> > > xterm -e 'vim -u NONE -N +"hi Normal ctermbg=red"'
> > > 
> > > # Insert a line of 50 spaces
> > > 50i<space><esc>
> > > 
> > > # Start moving the cursor left
> > > hhhhhhhhhh
> > > 
> > > # Notice that most of the screen is red, but the spaces that you've
> > > # moved over aren't colored and appear black.
> > > 
> > I can reproduce this.  If you hide and show the xterm window, they get
> > colored red again.
> 
> same here (looks like it got broken in one of my cleanup changes,
> since it's working in the binary I made on the 25th, but broken
> on the 28th).

hmm - further back.

It seems to be a bug introduced in this change for #242:

     * further amend fix for Debian #252873 from [252]patch #197 to treat
       a  blank  cell  which  does not have both foreground and background
       colored  as  a non-colored cell. This improves a special case where
       the  cursor  is on a blank cell which had foreground color scrolled
       in (report by Miroslav Lichvar).
       Also  add the same logic when hiding cursor, so the outline matches
       the in-focus cursor.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Tags added: confirmed, upstream Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Mon, 25 May 2009 17:39:24 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#522141; Package xterm. (Sun, 09 Aug 2009 21:57:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 09 Aug 2009 21:57:02 GMT) Full text and rfc822 format available.

Message #23 received at 522141@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 522141@bugs.debian.org
Subject: re: #522141 xterm 242 sometimes draws spaces without background color
Date: Sun, 09 Aug 2009 17:50:43 -0400
[Message part 1 (text/plain, inline)]
This is fixed in patch #244

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Added tag(s) fixed-upstream. Request was from Thomas Dickey <dickey@his.com> to control@bugs.debian.org. (Sun, 09 Aug 2009 21:57:05 GMT) Full text and rfc822 format available.

Reply sent to Julien Cristau <jcristau@debian.org>:
You have taken responsibility. (Mon, 10 Aug 2009 16:09:11 GMT) Full text and rfc822 format available.

Notification sent to Matt Wozniski <mjw@drexel.edu>:
Bug acknowledged by developer. (Mon, 10 Aug 2009 16:09:11 GMT) Full text and rfc822 format available.

Message #30 received at 522141-close@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: 522141-close@bugs.debian.org
Subject: Bug#522141: fixed in xterm 244-1
Date: Mon, 10 Aug 2009 15:51:00 +0000
Source: xterm
Source-Version: 244-1

We believe that the bug you reported is fixed in the latest version of
xterm, which is due to be installed in the Debian FTP archive:

xterm_244-1.diff.gz
  to pool/main/x/xterm/xterm_244-1.diff.gz
xterm_244-1.dsc
  to pool/main/x/xterm/xterm_244-1.dsc
xterm_244-1_i386.deb
  to pool/main/x/xterm/xterm_244-1_i386.deb
xterm_244.orig.tar.gz
  to pool/main/x/xterm/xterm_244.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 522141@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Julien Cristau <jcristau@debian.org> (supplier of updated xterm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Mon, 10 Aug 2009 16:30:29 +0200
Source: xterm
Binary: xterm
Architecture: source i386
Version: 244-1
Distribution: unstable
Urgency: low
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Changed-By: Julien Cristau <jcristau@debian.org>
Description: 
 xterm      - X terminal emulator
Closes: 378700 458432 522141 538594
Changes: 
 xterm (244-1) unstable; urgency=low
 .
   * New upstream release
     + remove a limit-check in ptydata.c, allowing Unicode values past 64k to
       be displayed using TrueType fonts (closes: #458432)
     + demote recent (xterm 242) change to Debian #252873 fix to experimental,
       ifdef'd out as EXP_BOGUS_FG (closes: #522141)
     + work around groff mapping of ASCII quotes using macros (requested by
       Reuben Thomas based on Colin Watson advice (closes: #378700)
   * Switch debian/rules to xsfbs instead of copying half of (an outdated
     version of) it (closes: #538594).  Incidentally, this provides
     README.source, and allows us to bump Standards-Version to 3.8.2.
   * Remove preinst dealing with upgrades from pre-etch versions.
   * Remove from postinst some code to fix pre-etch non-released versions.
   * Refresh/update patches.
   * Bump debian/compat to 5, as compatibility level 4 has been deprecated.
   * Remove obsolete debian/README.
Checksums-Sha1: 
 8484e62d1fcbcf0059f8a4e9ba40b48d1850f6aa 1339 xterm_244-1.dsc
 3393a28bfe19d23d5f234ec5bceafefd61c5986c 882642 xterm_244.orig.tar.gz
 155d89746199a8cbbfd868370e1c5c1791f88b0d 73013 xterm_244-1.diff.gz
 a890ba49613af766155956c418b76874c3212496 495426 xterm_244-1_i386.deb
Checksums-Sha256: 
 3758d663b5f4add240ac7fdc16ef0265dabadb2f2c68b41df50c7c1b4f230afd 1339 xterm_244-1.dsc
 b253870e0cc4d702a77ae63df1ed8933274f79d56060add48e8ee714ceac1e5b 882642 xterm_244.orig.tar.gz
 4be08c3ebe4cc7e9a46a72e3053cee14cbbc37f52b73b7898864bfb7b67c2cfc 73013 xterm_244-1.diff.gz
 28a1e3c2e9b37cf12c9d1d0057eed30eeed49b80830e1953ce7ed0d4986d726d 495426 xterm_244-1_i386.deb
Files: 
 084610a5c7f72f5f5d0b35d50ba14696 1339 x11 optional xterm_244-1.dsc
 9133a24dde377ad355139f5d6bc9b336 882642 x11 optional xterm_244.orig.tar.gz
 d842c65c7b40d17e89d45e09dc9b6b44 73013 x11 optional xterm_244-1.diff.gz
 61295959c9eb34352ed54bd57b930bbe 495426 x11 optional xterm_244-1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkqAL7oACgkQmEvTgKxfcAxktQCgpAuUS4CPkbLp2YrITM4+7sEf
wX8AnR3xrRKXLppS3ZqlAD5NleVTQtke
=H6v+
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 10 Sep 2009 07:29:12 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 14:08:08 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.